Menu/authorization: need alternative to rails controller centric authorization

05/01/2014 01:54 PM - Walden Raines

Status: Closed   

Priority: Normal   

Assignee:    

Category: Users, Roles and Permissions   

Target version: 1.6.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

The methods authorized? and allowed_to should be less controller centric.

In bastion we only have one controller:  

https://github.com/Katello/katello/blob/master/engines/bastion/app/controllers/bastion/bastion_controller.rb.  That controller simply

renders html, js, and css which in turn powers the application.

We cannot show menu items based on permissions because the menu item authorization relies on there being a controller `entity`

with an action `action`.  We need some way to specify the entity and action without undue reliance on the existence of a rails

controller.

One solution ehelms proposed was to "allow passing in a Proc to define a path or pass in 'url' if the user wants to".

References:

https://github.com/theforeman/foreman/blob/develop/app/services/menu/item.rb#L36

https://github.com/theforeman/foreman/blob/acfbc45886c4d81a2a3ca5af433a6124a0a7191a/app/models/role.rb#L79

Related issues:

Blocks Katello - Feature #5217: As a user, I should have CRUD permissions for... Closed 04/16/2014

Blocks Katello - Feature #5593: Fix menu so authorized items are displayed po... Closed 05/06/2014

Associated revisions

Revision 902c71ef - 05/07/2014 11:13 AM - Dmitri Dolguikh 

fixes #5537: it's possible to specify menu item url directly now

History

#1 - 05/01/2014 01:55 PM - Walden Raines

- Blocks Feature #5217: As a user, I should have CRUD permissions for all entities that are exposed to me. added

#2 - 05/06/2014 11:35 AM - Anonymous

- Status changed from New to Ready For Testing

- Assignee set to Anonymous

PR: https://github.com/theforeman/foreman/pull/1423

#3 - 05/06/2014 11:36 AM - Dominic Cleal

- Target version set to 1.8.3

#4 - 05/06/2014 07:05 PM - Walden Raines

- Blocks Feature #5593: Fix menu so authorized items are displayed post single page app work added

#5 - 05/07/2014 10:14 AM - Dominic Cleal
https://github.com/Katello/katello/blob/master/engines/bastion/app/controllers/bastion/bastion_controller.rb
https://github.com/theforeman/foreman/blob/develop/app/services/menu/item.rb#L36
https://github.com/theforeman/foreman/blob/acfbc45886c4d81a2a3ca5af433a6124a0a7191a/app/models/role.rb#L79
https://github.com/theforeman/foreman/pull/1423


- translation missing: en.field_release set to 10

#6 - 05/07/2014 11:31 AM - Anonymous

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 902c71ef6316b63ebff64773769cff477604a646.
